precision mediump float;

varying highp vec2 texCoord;
varying vec3 lightDir;
varying vec3 normal;

varying vec3 lightDirection;

uniform sampler2D diffuseTexture;
uniform sampler2D normalTexture;
uniform sampler2D gradientShadeTexture;

void main()
{
    vec3 n = texture2D(normalTexture, texCoord).xyz;

    n = (n * 2.0) - 1.0;

    vec4 diff = texture2D(diffuseTexture, texCoord);

    float LdotN = dot(lightDir, n);
    LdotN = (LdotN + 1.0) * 0.5;
    vec2 shadeLookUp = vec2(LdotN, 0);
    vec3 shading = texture2D(gradientShadeTexture, shadeLookUp).rgb;

    vec4 final = vec4(diff.rgb * shading, 1.0); // multiply the diffuse by the light direction

    gl_FragColor = final;
}