precision mediump float;

uniform vec3 uLightDirection;
//uniform vec3 uAmbientColor;
uniform vec3 uExposure;


varying vec2 texCoord0;
varying vec3 normal;
varying vec3 viewDir;

uniform sampler2D diffuseTexture;
uniform sampler2D gradientShadeTexture;
uniform sampler2D atmosphereGradientTexture;
uniform sampler2D nightTexture;

const float pi = 3.151;


void main()
{
    vec4 final;

    float tc_light = dot(normal, uLightDirection);
    tc_light = tc_light * 0.5 + 0.5;
    
    vec2 shadingTexLookup = vec2(tc_light, 0);
    vec4 shading = texture2D(gradientShadeTexture, shadingTexLookup);

    float tc_view = dot(normal, viewDir);
    //tc_view = tc_view * 0.5 + 0.5;
    tc_view = clamp(tc_view, 0.0, 1.0);

    vec2 atmosTexLookUp = vec2(tc_view, 0);
    vec4 atmosphere = texture2D(atmosphereGradientTexture, atmosTexLookUp) * shading;
    
    vec4 diff = texture2D(diffuseTexture, texCoord0) * shading;

    final = diff + atmosphere;
    //final = diff * shading + atmosphere * shading; // multiply the diffuse by the light direction, and add the atmosphere
    //final = diff * shading + (atmosphere * atmosphere.a)  * shading; // multiply the diffuse by the light direction, and add the atmosphere

    //final.rgb = diff.rgb * uAmbientColor + uAmbientColor + final.rgb ; //add in the ambient

    //final.rgb = v3DiffuseColor * uAmbientColor;// (c0 + v3DiffuseColor * c1); 
    //final.rgb += v3NightColor * uAmbientColor;// * vec3((1.0 - dayNightBlend)); // ambient only in night areas.
    
    final.a = 1.0;

    gl_FragColor = final;
}