precision mediump float;
precision lowp int;

uniform vec3 uLightDirection;

//Unique parameters
//const float maxFlowDistance = 0.5;//0.084;

varying vec2 texCoord0;

varying vec3 normal;
varying vec3 viewDir;

uniform sampler2D diffuseTexture;
uniform float uCloudAnimPhase;
uniform sampler2D gradientShadeTexture;
uniform sampler2D flowTexture;
uniform sampler2D mathTexture;

const float PI = 3.1415;

void main()
{
    vec3 flowTex = texture2D(flowTexture, texCoord0).rgb;
    float cycleOffset = flowTex.b;

    float blendA = texture2D(mathTexture, vec2(uCloudAnimPhase + cycleOffset, 0)).b; //mod(uCloudAnimPhase + cycleOffset, 1.0);
    float blendB = texture2D(mathTexture, vec2(blendA + 0.5, 0)).b; //mod(blendA + 0.5, 1.0);
    float lerpVal = texture2D(mathTexture, vec2(blendB, 0)).r; //sin(blendB * PI);
    
    vec2 flowVelocity = flowTex.rg - 0.5;

    float flowOffsetDistance = blendA;
    vec2 uvLookup = texCoord0 + (flowVelocity * flowOffsetDistance);

    vec4 layerA = texture2D(diffuseTexture, uvLookup);

    flowOffsetDistance = blendB;
    uvLookup = texCoord0 + (flowVelocity * flowOffsetDistance);

    vec4 layerB = texture2D(diffuseTexture, uvLookup);

    vec4 diff = mix(layerA, layerB, lerpVal);
    
    float tc_light = dot(normal, uLightDirection);
    tc_light = tc_light * 0.5 + 0.5;
    
    vec2 shadingTexLookup = vec2(tc_light, 0);
    vec4 shading = texture2D(gradientShadeTexture, shadingTexLookup);
    
    vec4 final = diff * shading;

    final.a = 1.0;
    
    gl_FragColor = final;
}