precision mediump float;

//uniform vec3 uAmbientColor;

//Material parameters
//const float fExposure = 1.5;

varying highp vec2 texCoord;
varying vec3 lightDir;
varying vec3 normal;

varying vec3 lightDirection;

uniform sampler2D diffuseTexture;
uniform sampler2D normalTexture;
uniform sampler2D gradientShadeTexture;

void main()
{
    vec3 n = texture2D(normalTexture, texCoord).xyz;
    n = (n * 2.0) - 1.0;
    n = clamp(n, 0.0, 1.0);
           
    float LdotN = dot(lightDir, n);
        
    LdotN = (LdotN + 1.0) * 0.5;

    vec2 shadeLookUp = vec2(LdotN, 0);
    vec3 shading = texture2D(gradientShadeTexture, shadeLookUp).rgb;

    vec4 diff = texture2D(diffuseTexture, texCoord);
    vec4 final = vec4(diff.rgb * shading, 1.0); // multiply the diffuse by the lighting
    

    gl_FragColor = final;
        
    //float value = dot(uLightDirection, normal);
    //gl_FragColor = vec4(tc_light, tc_light, tc_light, 1.0);
    //gl_FragColor = vec4(shading, 1.0);
    //gl_FragColor = vec4(LdotN, LdotN, LdotN, 1.0);
}