precision lowp float;

uniform vec3 uLightDirection;
uniform vec3 uAmbientColor;
uniform vec3 uExposure;
uniform vec3 uEyePos;
uniform vec4 uColor;

varying vec2 texCoord0;
varying vec3 normal;
varying vec3 viewDir;

uniform sampler2D diffuseTexture;
uniform sampler2D gradientShadeTexture;

void main()
{
    vec4 final;

    float tc_light = dot(normal, uLightDirection);
    tc_light = tc_light * 0.5 + 0.5;

    vec2 atmosTexLookup = vec2(tc_light, 0);
    vec3 shading = texture2D(gradientShadeTexture, atmosTexLookup).rgb; //optimise by using only 1 channel in the texture
    
    vec4 diff = texture2D(diffuseTexture, texCoord0);
    
    final = vec4(diff.rgb * shading, 1.0); // multiply the diffuse by the light direction
    
    //final.rgb = diff.rgb * uAmbientColor + uAmbientColor + final.rgb ; //add in the ambient
    
    gl_FragColor = texture2D(diffuseTexture, texCoord0) * uColor;
}