precision mediump float;
precision lowp int;

//uniform vec3 uLightDirection;

//Unique parameters
//const float maxFlowDistance = 0.5;//0.084;

varying vec2 texCoord0;

varying vec3 normal;
varying vec3 viewDir;

uniform sampler2D diffuseTexture;
uniform float uCloudAnimPhase;
uniform sampler2D gradientShadeTexture;
uniform sampler2D flowTexture;
uniform sampler2D mathTexture;
uniform vec4 uFresnelColor;

const float pi = 3.1415926535;

void main()
{
	vec3 flowTex = texture2D(flowTexture, texCoord0).rgb;
	float noise = texture2D(diffuseTexture, texCoord0).b;
	float cycleOffset = flowTex.b;

	float blendA = texture2D(mathTexture, vec2(uCloudAnimPhase + cycleOffset, 0)).b; //mod(uCloudAnimPhase + cycleOffset, 1.0);
	float blendB = texture2D(mathTexture, vec2(blendA + 0.5, 0)).b; //mod(blendA + 0.5, 1.0);
	float lerpVal = texture2D(mathTexture, vec2(blendB, 0)).r; //sin(blendB * PI);
	
	vec2 flowVelocity = flowTex.rg - 0.5;

   	float flowOffsetDistance = blendA;
   	vec2 uvLookup = texCoord0 + (flowVelocity * flowOffsetDistance);

   	float layerA = texture2D(diffuseTexture, uvLookup).r;

	flowOffsetDistance = blendB;
   	uvLookup = texCoord0 + (flowVelocity * flowOffsetDistance);

	float layerB = texture2D(diffuseTexture, uvLookup).r;

	float diff = mix(layerA, layerB, lerpVal);
	
	vec4 colorDiff = texture2D(gradientShadeTexture, vec2(diff * noise, 0));
	
	vec4 final = colorDiff + (uFresnelColor * (1.0 - dot( viewDir, normal))) ;
	
	final.a = 1.0;
	
	gl_FragColor = final;
}